--this file is run (by default) by Resound, and adds additional "tags" to the sectors

lib.log_error("[Resound] extra tag handlers are now loading", 2, "Resound", "0")

local rse = lib.get_class("resound", "0").get_rse()

--combat tag checks

local combat_distance = tonumber(gkini.ReadString("Resound", "combat_distance", "1500")) --distance before combat triggers
local in_combat_reset = tonumber(gkini.ReadString("Resound", "combat_reset_time", "20")) --num seconds before combat distance is re-checked
local in_combat_timestamp = 0 --timestamp of last combat check

--RegisterEvent(function() in_combat_timestamp = 0 end, "PLAYER_LEAVES_SECTOR") --reset timestamp when player leaves sector

local is_combat_recent = function()
	return not (in_combat_reset < (os.time() - in_combat_timestamp))
end

local combat_distance = function(self)
	--checks if the player is close enough to an NPC to trigger combat
	if is_combat_recent() then
		console_print("Combat recency check returned true!")
		self:require_tag("combat", true)
		return
	end
	
	local break_flag = false --if we find a combat trigger, instant skip others (too bad we can't just use a break statement T.T
	
	ForEachPlayer(
		function(id)
			if break_flag then
				return
			end
			local val = GetFriendlyStatus(id)
			if (val < 3) and ((GetPlayerDistance(id) or 10000) < combat_distance) then
				self:require_tag("combat", true)
				in_combat_timestamp = os.time()
				break_flag = true
				console_print("Combat flag tripped on user id: " .. tostring(id))
			end
		end
	)
	
	if (not break_flag) and (self:get_tag("combat")) then
		self.forced_tags["combat"] = nil
		self:toggle_tag("combat", false)
		self.reset_tag_check = true
		console_print("Resetting combat flag")
	end
end

rse:new_scanning_tag(combat_distance)

local combat_impact = function(event, attacked, attacker, dmg, dmg_type)
	--combat triggered by being hit by an enemy
	if attacked ~= attacker and dmg_type then
		rse:toggle_tag("combat", true)
		in_combat_timestamp = os.time()
	end
end

RegisterEvent(combat_impact, "PLAYER_GOT_HIT")



-- distant tag check

local distant_check = function(self)
	local flag = radar.GetNearestObjectDistance() > 3000
	flag = flag or radar.GetNearestObjectDistance() < 0
	self:toggle_tag("distant", flag)
end

rse:new_scanning_tag(distant_check)



-- inner/outer entry check

local region_check = function(self)
	self:toggle_tag("outer", false)
	self:toggle_tag("inner", false)
	local system_num = GetCurrentSystemid() or 0
	self:toggle_tag(system_num > 30 and "outer" or "inner", true)
end

rse:new_entry_tag(region_check)



-- capitol system entry check

local capital_check = function(self)
	local system_num = GetCurrentSystemid() or 0
	local  flag =  system_num == 1
	flag = flag or system_num == 9
	flag = flag or system_num == 19
	flag = flag or system_num == 22
	flag = flag or system_num == 31
	self:toggle_tag("capital", flag)
end

rse:new_entry_tag(capital_check)



-- deneb entry check

local deneb_check = function(self)
	local system_num = GetCurrentSystemid() or 0
	self:toggle_tag("deneb", system_num == 4)
end

rse:new_entry_tag(region_check)



